JerkScript = LibStub("AceAddon-3.0"):NewAddon("JerkScript", "AceComm-3.0", "AceConsole-3.0", "AceEvent-3.0");
local randomNumber = 0;
local jerkQuote = "";
local cmdJerkCD = 0;
local cmdJerkSpamTimer = 3;
local cmdJerkoffCD = 0;
local cmdJerkoffSpamTimer = 60;
local frame = CreateFrame("FRAME");
local myName = UnitFullName("player") .. "-" .. GetRealmName();
local version = GetAddOnMetadata("JerkScript", "Version") or 9999;
JerkScript.remoteVersion = version;
JerkScript.prefixColor = '|cffffff00';
JerkScript.chatColor = '|cffffffff';

function JerkScript:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("JerkScriptDB");
	SLASH_JERK1 = '/jerk';
	SlashCmdList["JERK"] = JerkScript.GetJerkQuote;
	SLASH_GOOGLY2 = '/googly';
	SlashCmdList["GOOGLY"] = JerkScript.SendGoogly;
	self:RegisterEvents();
end

function JerkScript:RegisterEvents()

	frame:RegisterEvent("ADDON_LOADED");
	frame:RegisterEvent("VARIABLES_LOADED");
	frame:RegisterEvent("CHAT_MSG_SAY");
	frame:RegisterEvent("CHAT_MSG_GUILD");
	frame:RegisterEvent("CHAT_MSG_RAID");
	frame:RegisterEvent("CHAT_MSG_YELL");
	frame:RegisterEvent("CHAT_MSG_PARTY");
	frame:SetScript("OnEvent", function(self, event, message, sender)
		if ((event == "CHAT_MSG_SAY" or event == "CHAT_MSG_GUILD" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_YELL" or event == "CHAT_MSG_PARTY")) then
			if (message:lower():match("!jerkoff")) then
				local jerkCmd, jerkTarget = string.match(message, '(%a+) ([%w\128-\244]+)');
				if (jerkTarget == nil) then
					-- Player is informed they didn't nominate someone to be jerked.
					JerkScript:Print('You must specify a target to jerkoff.');
					return true;
				elseif ((GetServerTime() - cmdJerkoffCD) > cmdJerkoffSpamTimer) then
					-- Start the spam timer.
					cmdJerkoffCD = GetServerTime();
					-- Create the whisper command.
					sendToUser = "whisper " .. jerkTarget;
					-- Send the jerkscript to the target.
					JerkScript:Print('You are jerking off ' .. jerkTarget:gsub("^%l", string.upper) .. '!');
					JerkScript.GetJerkQuote(sendToUser);
				else
					-- To limit excessive usage of this command, Player must wait for cooldown.
					JerkScript:Print('You can only jerkoff so many times in such a short timeframe!');
				end
			elseif (message:lower():match("!jerk")) then
				if (sender ~= myName) then
					-- Send jerkscripts to the person requesting them.
					sendToUser = "whisper " .. sender;
					JerkScript.GetJerkQuote(sendToUser);
				else
					-- Player sent the request and will not send a jerkscript to themself.
				end
			end
		end
	end);
	JerkScript:Print('LOADED AND READY TO FUCK! (' .. JerkScript.prefixColor .. version .. JerkScript.chatColor .. ')');

end

function JerkScript:SendMsg(param1, jerkQuote)
	
		-- Checks if commands have been spammmed
	if ((GetServerTime() - cmdJerkCD) > cmdJerkSpamTimer) then
		-- Set cooldown period.
		cmdJerkCD = GetServerTime();
	else 
		-- Exit function due to cooldown.
		self:Print('You must rest before jerking off again.');
		return true;
	end
	
	-- Check what channel script should be sent to.
	local start, finish, command, value = string.find(param1, "(%w+) ([%w\128-\244]+)");
	if (string.lower(param1) == "say") or (string.lower(param1) == "yell") or (string.lower(param1) == "party") or (string.lower(param1) == "guild") or (string.lower(param1) == "raid") or (string.lower(param1) == "raid_warning") or (string.lower(param1) == "officer") then
		SendChatMessage(jerkQuote, param1, nil);
	elseif (string.lower(param1) == "rw") then
		SendChatMessage(jerkQuote, "raid_warning", nil);
	elseif (string.lower(param1) == "target") then
		SendChatMessage(jerkQuote, "whisper", nil, GetUnitName("PLAYERTARGET"));
	elseif (string.lower(param1) == "bg") then
		SendChatMessage(jerkQuote, "battleground", nil);
	elseif (string.lower(param1) == "instance") then
		SendChatMessage(jerkQuote, "instance_chat", nil);
	elseif (string.lower(param1) == "1") or (string.lower(param1) == "2") or (string.lower(param1) == "3") or (string.lower(param1) == "4") or (string.lower(param1) == "5") or (string.lower(param1) == "6") or (string.lower(param1) == "7") or (string.lower(param1) == "8") or (string.lower(param1) == "9") then
		local MyChannel = GetChannelName(param1);
		if (MyChannel ~= nil) then
			SendChatMessage(jerkQuote, "CHANNEL", nil, MyChannel);
		end
	elseif (string.lower(param1) == "local") then
		JerkScript:Print(jerkQuote);	
	elseif (string.lower(param1) == "whisper" and command ==nil) then
		JerkScript:Print("You must enter a name to whisper to.");
	elseif (command ~=nil and string.lower(command) == "whisper") then
		if (value ~=nil) then
			SendChatMessage(jerkQuote, "WHISPER", nil, value);
		end	
	else
		JerkScript:UnknownCommand();
	end
end

function JerkScript:GetVersion()
	-- Returns current version.
	JerkScript:Print("Version - " .. JerkScript.prefixColor .. version);
end

function JerkScript.GetJerkQuote(jerkTarget)

	-- Check if options or unknown command.
	if (string.lower(jerkTarget) == "help") then
		JerkScript:HowTo();
	elseif (string.lower(jerkTarget) == "version") or (string.lower(jerkTarget) == "v") then
		JerkScript:GetVersion();
	elseif (string.lower(jerkTarget) == '') then
		JerkScript:UnknownCommand();
	else
		-- Gets random quote to send to chat.
		numberQuotes = table.getn( JerkScriptQuotes );
		randomNumber = math.random( numberQuotes );
		jerkQuote = JerkScriptQuotes[randomNumber];
		jerkQuote = jerkQuote:upper();
		JerkScript:SendMsg(jerkTarget, jerkQuote);
	end

end

function JerkScript.SendGoogly(jerkTarget)
	-- Sets googly face as chat message.
	jerkQuote = "¯\\(°_o)/¯";
	JerkScript:SendMsg(jerkTarget, jerkQuote);
end

function JerkScript:HowTo() 
	-- Instructions on how to use JerkScript.
	JerkScript:Print(JerkScript.prefixColor .. "HOW TO USE JERKSCRIPT:");
	JerkScript:Print(JerkScript.prefixColor .. "Action: " .. JerkScript.chatColor .."/jerk " .. JerkScript.prefixColor .. "or " .. JerkScript.chatColor .. "/googly");
	JerkScript:Print(JerkScript.prefixColor .. "Channel: " .. JerkScript.chatColor .. "raid " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "rw " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "say" .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "yell " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "party " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "officer " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "target " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "local " .. JerkScript.prefixColor .. "| " .. JerkScript.chatColor .. "whisper " .. JerkScript.prefixColor .. "<" .. JerkScript.chatColor .. "PlayerName" .. JerkScript.prefixColor .. "> | <" .. JerkScript.chatColor .. "ChannelNumber" .. JerkScript.prefixColor .. ">");
	JerkScript:Print(JerkScript.prefixColor .. "!jerk " .. JerkScript.chatColor .. "to be jerked off.");
	JerkScript:Print(JerkScript.prefixColor .. "!jerkoff <" .. JerkScript.chatColor .. "PlayerName" .. JerkScript.prefixColor .. "> " .. JerkScript.chatColor .. "to jerk someone off.");
end

function JerkScript:UnknownCommand() 
	-- Instructions on how to use JerkScript.
	JerkScript:Print("Unknown command. Type " .. JerkScript.prefixColor .. "/jerk help " .. JerkScript.chatColor .. "to see a list of commands.");
end

function JerkScript:SendMessage(jerkMessage)
	-- Send JerkScript message.
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage(jerkMessage);
	end
end